/****************************************************/
/* make filelist                                    */
/*                                                  */
/* t@CZN^PʂŊi[邽߂̃Xg */
/****************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define	MAXFILE		63
#define	MAXNAME		16


int main(int argc, char **argv)
{
	FILE	*infp, *outbinfp, *outtxtfp, *flistfp;

	int		i,j;
	char	fname[MAXNAME];
	char	addstr[MAXNAME];
	int		stadd,fsize,foffset;
	int		filelen;
	int		readflag;

	int		diskno,trackno, secno;

	if (argc != 7) {
		fprintf(stderr, "Usage: mkflist diskno starttrack startsector inputlist outbinlist outtxtlist\n");
		exit(1);
	}

	diskno  = atoi(argv[1]);
	trackno = atoi(argv[2]);
	secno   = atoi(argv[3]);

/* open files */

	if ((infp = fopen(argv[4], "r")) == NULL) {
		perror(argv[4]);
		exit(1);
	}

	if ((outbinfp = fopen(argv[5], "wb")) == NULL) {
		perror(argv[5]);
		exit(1);
	}

	if ((outtxtfp = fopen(argv[6], "w")) == NULL) {
		perror(argv[6]);
		exit(1);
	}

	fputc(diskno,outbinfp);
	for (j = 1;j < 16;j ++) {
		fputc(0x00, outbinfp);
	}

	for (i = 0;i < MAXFILE;i ++) {
		if (fscanf(infp,"%s",fname) != EOF) {
			if (fscanf(infp,"%s",addstr) == EOF) {
				printf("no address\n");
				exit(1);
			}
			sscanf(addstr,"0x%x",&stadd);

			if (fscanf(infp,"%s",addstr) == EOF) {
				printf("no file size\n");
				exit(1);
			}
			sscanf(addstr,"0x%x",&fsize);

			if (fscanf(infp,"%s",addstr) == EOF) {
				printf("no offset\n");
				exit(1);
			}
			sscanf(addstr,"0x%x",&foffset);

			if ((flistfp = fopen(fname, "rb")) == NULL) {
				perror(fname);
				exit(1);
			}

			fseek(flistfp, 0, SEEK_END);
			filelen = ftell(flistfp);
			filelen = ( (filelen+0x00ff) & 0xff00);
			fclose(flistfp);

			for (j = 0;j < strlen(fname);j ++) {
				fputc(fname[j], outbinfp);
			}
			for (;j < 6;j ++) {
				fputc(0x00, outbinfp);
			}

			fputc(foffset & 0x00ff, outbinfp);
			fputc( (foffset & 0xff00) >> 8, outbinfp);

			fputc(stadd & 0x00ff, outbinfp);
			fputc( (stadd & 0xff00) >> 8, outbinfp);

			fputc(fsize & 0x00ff, outbinfp);
			fputc( (fsize & 0xff00) >> 8, outbinfp);

			fputc(trackno, outbinfp);
			fputc(secno+1, outbinfp);

			fputc( 0x00, outbinfp);
			fputc( (filelen >> 8), outbinfp);

			fprintf(outtxtfp,"%s 0 %d %d\n", fname, trackno, secno+1);


			secno   = secno + (filelen >> 8);
			trackno = trackno + ( (secno & 0xfff0) >> 4);
			secno   = (secno & 0x000f);

		} else {
			for (j = 0;j < 16;j ++) {
				fputc(0x00, outbinfp);
			}
		}

	}

	fclose(infp);
	fclose(outbinfp);
	fclose(outtxtfp);

	return(0);

}

