;
; wi`pvO
;

	relaxed on

DISKBUF		equ	$af00

INC_V		equ	$0102
VADDRCONV	equ	$0105
FILLBACKSET0	equ	$0108
COLORDAT	equ	$5c00
CLSDATA		equ	$5c02

CALCCHRADD	equ	$1d01

	org	$2000

	jp	CLSLINE		; 0x2000
	jp	SCRFILL		; 0x2003
	jp	DRAWLINEHSUB	; 0x2006
	jp	DRAWLINEVSUB	; 0x2009
	jp	PUT1LETTERSUB	; 0x200c
	jp	SCROLLSUB	; 0x200f
	jp	RACCVRAM	; 0x2012
	jp	RACCMRAM	; 0x2015
	jp	BACKBUFSUB	; 0x2018
	jp	DISPEXITSUB	; 0x201b
	jp	DISPBACKBUFSUB	; 0x201e

	org	$2030
;
; _[Wp^[pobt@
;
DMGPAT:
	db	100 dup ($00)


;
; P\Tui16x8j
;
PUT1LETTERSUB:
	ld	(.col+1),bc

	ld	c,2
.lp2:
	ld	b,4
	push	hl
.lp1:
	push	bc
	ex	de,hl

.col:	ld	bc,$0000	; 1ɃZbg鎞0x00A0ɂ鎞0xff

	ld	a,ixl		; wi#0
	xor	c
	or	(hl)		; v[#0
	xor	c
	ld	(de),a
	inc	e

	ld	a,ixu		; wi#1
	xor	b
	or	(hl)		; v[#1
	inc	hl
	xor	b
	ld	(de),a
	inc	e

	ld	a,ixl		; wi#0
	xor	c
	or	(hl)		; v[#0
	xor	c
	ld	(de),a
	inc	e

	ld	a,ixu		; wi#1
	xor	b
	or	(hl)		; v[#1
	inc	hl
	xor	b
	ld	(de),a
	dec	e
	dec	e
	dec	e

	ex	de,hl

	ld	a,h
	cp	$1a+$80
	jr	nc,.left

	call	INC_V
	dec	h

.left:	inc	h

	pop	bc
	djnz	.lp1

	pop	hl

	ld	a,l
	add	a,4
	ld	l,a

	call	c,VADDRCONV

	dec	c
	jr	nz,.lp2

	ret

;
; 
;
DRAWLINEHSUB:
	call	RACCVRAM
	call	DRAWLINEH_SUB
	call	RACCMRAM
	ret

;
; c
;
DRAWLINEVSUB:
	call	RACCVRAM
	call	DRAWLINEV_SUB
	call	RACCMRAM
	ret

;
; 0x8000`0xFFFF̓ǂݏoVRAMɂ
;
RACCVRAM:
	push	af
	xor	a
	jr	RACCMRAM.cont

;
; 0x8000`0xFFFF̓ǂݏoORAMɂ
;
RACCMRAM:
	push	af
	ld	a,$28
.cont:
	out	($64),a
	add	a,2
	out	($65),a
	add	a,2
	out	($66),a
	add	a,2
	out	($67),a
	pop	af
	ret

; c
; HLFVRAMAhX
; CF`f[^
; BFchbg
; (COLORDAT+0,1)FF
;
DRAWLINEV_SUB:

	ld	de,(COLORDAT)
	ld	a,e
	and	c			; }XN
	ld	e,a

	ld	a,d
	and	c			; }XN
	ld	d,a

	ld	a,c
	cpl
	ld	c,a			; Ȃ

	bit	1,l
	jr	nz,.odd

.lp1:
	ld	a,(hl)
	and	c
	or	e
	ld	(hl),a
	inc	l
	ld	a,(hl)
	and	c
	or	d
	ld	(hl),a
	inc	l

	dec	b
	ret	z

.odd:
	ld	a,(hl)
	and	c
	or	e
	ld	(hl),a
	inc	l
	ld	a,(hl)
	and	c
	or	d
	ld	(hl),a

	dec	l
	dec	l
	dec	l

	ld	a,h
	cp	$1a+$80
	jr	nc,.left

	call	INC_V
	dec	h

.left:	inc	h
.next:
	djnz	.lp1
	ret

; 
; HLFVRAMAhX
; DFJnrbg
; BCFhbg
; (COLORDAT+0,1)FF
;
DRAWLINEH_SUB:
	ld	a,b
	inc	a
	ex	af,af'
	ld	b,c

	ld	c,d

	ld	a,h
	cp	$9a
	ret	c

	ex	af,af'
.lp2:
	ex	af,af'
.lp1:
	ld	de,(COLORDAT)
	ld	a,e
	and	c			; }XN
	ld	e,a

	ld	a,d
	and	c			; }XN
	ld	d,a

	ld	a,c
	cpl
	and	(hl)
	or	e
	ld	(hl),a
	inc	l

	ld	a,c
	cpl
	and	(hl)
	or	d
	ld	(hl),a
	dec	l

	rrc	c
	jr	nc,.next

	ld	a,l
	add	a,4
	ld	l,a
	jr	nc,.next

	call	VADDRCONV

.next:
	djnz	.lp1

	ex	af,af'
	dec	a
	jr	nz,.lp2

	ret

;
; ʃNAiFILLj
; ix^0̂ݑΉj
SCRFILL:
	push	af
	push	bc
	push	de
	push	hl
	push	ix
	push	iy

	call	FILLBACKSET0

	ld	bc,$6400

	call	CLSLINE

	pop	iy
	pop	ix
	pop	hl
	pop	de
	pop	bc
	pop	af
	ret

;
; 2xNs
; CFYW
; BFs(=N)
;
CLSLINE:

.lp3:
	ld	a,c
	call	CALCVRAM_L
	inc	h
	ld	(.vl+1),hl

	call	CALCVRAM_R
	ld	de,$0040
	add	hl,de
	ld	(.vr+1),hl

	push	bc

	ld	hl,(CLSDATA+6)	; 8,7oCg( 8,1)-(15,1)
	ld	de,(CLSDATA+2)	; 4,3oCg( 0,1)-( 7,1)
	ld	ix,(CLSDATA+4)	; 6,5oCg( 8,0)-(15,1)
	ld	iy,(CLSDATA+0)	; 2,1oCg( 0,0)-( 7,0)

	di
	ld	(.sppt+1),sp

	ld	b,16
.vl:	ld	sp,$0000
.lp1:
	push	hl
	push	de
	push	ix
	push	iy
	push	hl
	push	de
	push	ix
	push	iy
	djnz	.lp1

	ld	b,4
.vr:	ld	sp,$0000
.lp2:
	push	hl
	push	de
	push	ix
	push	iy
	push	hl
	push	de
	push	ix
	push	iy
	djnz	.lp2

.sppt:	ld	sp,$0000
	ei

	pop	bc

	inc	c
	inc	c
	djnz	.lp3

	ret

;
; VRAMAhXZoij
; AFYW
; RETURN
; HLFVRAMAhX
;
CALCVRAM_L:
	push	af

	srl	a
	add	a,$9a
	ld	h,a
	ld	l,$00

	pop	af
	ret

;
; VRAMAhXZoiEj
; AFYW
; RETURN
; HLFVRAMAhX
;
CALCVRAM_R:
	push	af

	ld	h,a

	and	$0c			; Y3,2
	add	a,a
	add	a,a
	add	a,a
	add	a,a			; Y3,2 => b7,6
	ld	l,a

	ld	a,h
	and	$f0			; Y7-4
	rrca
	rrca
	rrca				; Y7-4 => b12-9
	bit	1,h
	jr	z,.nob82
	inc	a			; Y1 => b8
.nob82:
	add	a,$80
	ld	h,a

	pop	af
	ret

;
; Xe[^XEʂobt@ɑޔiXN[pj
; (200,152)-(+14*8,+5*8)
;
SCROLLSUB:

	xor	a
	out	($64),a		; 0x8000-0x9FFFAVRAMi0x0000`0x1FFFjǂݏo
	ld	a,$08
	out	($6c),a		; 0x8000-0x9FFFA0x8000-0x9FFFɑ΂ď

	ld	de,$8000

	ld	a,152
	ld	b,5*8

.lp1:
	out	($ce),a
	inc	a
	push	bc

	ld	hl,$8000+200
	ld	bc,14*8
	ldir

	pop	bc
	djnz	.lp1

	ld	b,14*8*8/4
	ld	c,$0f
	ld	a,$00
	ex	de,hl
.lp2:
	ld	(hl),c		; v[#0F
	inc	hl
	ld	(hl),c		; v[#0F
	inc	hl
	ld	(hl),a		; v[#1F
	inc	hl
	ld	(hl),a		; v[#1F
	inc	hl
	djnz	.lp2

	xor	a
	out	($6c),a		; 0x8000-0x9FFFAVRAMɏ
	ld	a,$08
	out	($64),a		; 0x8000-0x9FFFA0x8000-0x9FFFǂݏo

	ret



;
; wiOtBbN̈ꕔޔ
; (88, 90)-(107,189)
; 0x4758-0x516b
;       :
; 0x7858-0x786b
;
BACKBUFSUB:
	ld	a,$08
	out	($6e),a		; 0xC000-0xDFFF݂̏0x8000-0x9FFFɂ

	call	RACCVRAM	; 0x8000-0xFFFF̓ǂݏoVRAMɂ

	ld	de,$c000	; obt@擪

	ld	b,100/2		; chbg/2
	ld	hl,$4758+$8000	; (88,110)
.lp2:
	push	bc
	push	hl

	ld	bc,10*$0100+$ff	; hbgoCgiQsPFj
.lp1:
	ldi
	inc	hl
	djnz	.lp1

	pop	hl
	inc	h

	pop	bc
	djnz	.lp2

	ld	a,$04
	out	($6e),a		; 0xC000-0xDFFF݂̏0x4000-0x5FFFɂ

	call	RACCMRAM	; 0x8000-0xFFFF̓ǂݏoO0x8000-0xFFFFɂ

	ld	hl,$6d58+$8000	; VRAMi176,166)

	ret

;
; 40x20̃L\idˍ킹j
; AFLԍ
; HLFVRAMAhX
DISPEXITSUB:
	push	af
	push	hl


	ld	a,$08
	out	($66),a		; 0xC000-0xDFFF̓ǂݏoA0x8000-0x9FFFɂ

	call	BACKBUFCALC
	ex	de,hl


	ld	de,BACKDAT

	ld	b,5
.lp2:
	push	bc

	ld	bc,10*$0100+$ff
.lp1:
	ldi
	ldi

	ld	a,10-2
	add	a,l
	ld	l,a
	jr	nc,.nc1
	inc	h
.nc1:
	djnz	.lp1

	ld	bc,-100+2
	add	hl,bc

	pop	bc
	djnz	.lp2


	ld	a,$2c
	out	($66),a		; 0xC000-0xDFFF̓ǂݏoAO0xC000-0xDFFFɂ


	pop	hl
	pop	af

	push	hl

	push	hl			; VRAMAhX
	call	CALCCHRADD
	ld	(DISPFB40x20.chad+1),hl	; LN^AhX
	pop	de			; VRAMAhX

	ld	hl,BACKDAT		; wif[^

	call	DISPFB40x20

	pop	hl

	ld	a,20/2
	add	a,h
	ld	h,a

	ret


; ޔ20x4̔wiL\
; HLFVRAMAhX
DISPBACKBUFSUB:


	ld	a,$08
	out	($66),a		; 0xC000-0xDFFF̓ǂݏoA0x8000-0x9FFFɂ

;
; 0x8000` (88,110)-(107,189) ̃f[^
;

	call	BACKBUFCALC
	ex	de,hl

	ld	b,4/2		; c
.lp2:
	push	bc
	push	de

	ld	b,10		; hbgoCgiQsPFj
.lp1:
	ld	a,(hl)
	ld	(de),a
	inc	hl
	inc	de
	ld	(de),a
	inc	de
	djnz	.lp1

	pop	de
	inc	d

	pop	bc
	djnz	.lp2


	ld	a,$2c
	out	($66),a		; 0xC000-0xDFFF̓ǂݏoAO0xC000-0xDFFFɂ

	ret

;
; wiobt@̐擪AhXZo
; HLFVRAMAhX
; RETURN
; DEFwiobt@擪
;
BACKBUFCALC:
	push	hl

	ld	a,h
	sub	$47+$80
	ld	h,0
	ld	l,a
	ld	d,h
	ld	e,l
	add	hl,hl		; x2
	add	hl,hl		; x4
	add	hl,de		; x5
	add	hl,hl		; x10
	ld	de,$c000	; obt@擪
	add	hl,de
	ex	de,hl

	pop	hl
	ret

;
; LN^{wi`i40hbgAc20hbgji퓬pj
; DEFP6pVRAMAhX
; HLFwip^[AhX
; (.chad+1)FLN^AhX
;
DISPFB40x20:

	ld	b,5
.lp2:
	push	bc
	push	de
	ld	a,10
.lp1:
	ex	af,af'

	di
	ld	(.sppt+1),sp
.chad:	ld	sp,$0000	; LN^AhX

	pop	bc
	ld	a,b
	or	c
	cpl
	and	(hl)
	inc	hl
	ld	iyu,a

	or	c
	ld	(de),a		; v[#0
	inc	e
	ld	a,iyu
	or	b
	ld	(de),a		; v[#1
	inc	e

	pop	bc
	ld	a,b
	or	c
	cpl
	and	(hl)
	inc	hl
	ld	iyu,a

	or	c
	ld	(de),a		; v[#0
	inc	e
	ld	a,iyu
	or	b
	ld	(de),a		; v[#1
	dec	e
	dec	e
	dec	e
	inc	d

	ld	(.chad+1),sp	; LN^AhX
.sppt:	ld	sp,$0000
	ei

	ex	af,af'
	dec	a
	jr	nz,.lp1

	pop	de
	inc	e
	inc	e
	inc	e
	inc	e
	pop	bc
	djnz	.lp2

	ret

;
; dˍ킹pobt@i5x20j
; iGA͊mۂȂj
;
BACKDAT:


; 0x27ff
; vȌI
;
	org	$23ff
	db	$ff


end
