;
; Np
;

	relaxed on

Disk_Info	equ	$ac00
Disk_Routine	equ	$ac01

Disk_Init	equ	Disk_Routine+0
Disk_Load	equ	Disk_Routine+3
Disk_Change1DD	equ	Disk_Routine+12


	org	$c000

;
; Track#0 Sector#1`
;
	db	"IPL"		; +0
	jr	START		; +3

;
; ZN^ǂݍ݁iROM[`gpj
;
READ_NSEC:
.loop:
	push	af
	ld	a,$01
	or	a
	push	bc
	push	de
	call	$0198		; ZN^ǂݍ
	pop	de
	pop	bc
	inc	d
	inc	c
	pop	af
	dec	a
	jr	nz,.loop
	ret

START:
	ld	sp,$c300

	xor	a		; hCuԍ-1
	ld	($ed66),a

	ld	bc,$0002	; Breg:gbNԍACreg:ZN^ԍ
	ld	de,$c100	; i[AhX
	ld	a,$01		; ǂݍރZN^
	call	READ_NSEC

	call	CURCLS


	ld	c,$06		; CregFZN^ԍiOthCupǂݏo[`j

	ld	a,($ed5a)	; bit7`0 = Ot#2A#1A#2A#1A"0000"
	bit	4,a
	jr	z,.fd_ex
	add	a,a
	add	a,a

	ld	c,$03		; CregFZN^ԍihCupǂݏo[`j
.fd_ex:

	rlca
	and	$01
	ld	(Disk_Info),a	; bit0 = Ot/#2

;
; fBXN[`[hiROM[`̑j
;
	ld	b,$00		; BregFgbNԍ
	ld	de,Disk_Routine	; i[擪AhX
	ld	a,$03		; ǂݍރZN^
	call	READ_NSEC

;
; fBXN[`̏
;
	ld	d,$00
	call	Disk_Init
	jr	c,.diskng

	ld	d,$00
	call	Disk_Change1DD
	jr	c,.diskng

	di

;
; VRAMNA
;
	ld	hl,$0000
.lp1:	ld	(hl),$88
	inc	hl
	ld	a,h
	cp	$80
	jr	nz,.lp1

;
; 0x0000`0xBFFF̃̓ǂݏOt
;
	ld	b,$06
	ld	de,$6068
	ld	a,$20
.outlp1:
	ld	c,d
	out	(c),a
	ld	c,e
	out	(c),a
	inc	a
	inc	a
	inc	d
	inc	e
	djnz	.outlp1

;
; 0xE000`0xFFFF̃̓ǂݏOt
;
	ld	a,$2e
	out	($67),a
	out	($6f),a

;
; OtRAM̃`FbN
;
	ld	bc,$5aa5
	ld	hl,$0000
	ld	(hl),b
	ld	h,$40
	ld	(hl),c
	ld	h,$80
	ld	(hl),$96

	ld	h,$00
	ld	a,(hl)
	cp	b
	jr	nz,.ramng
	ld	h,$40
	ld	a,(hl)
	cp	c
	jr	nz,.ramng
	ld	h,$80
	ld	a,(hl)
	cp	$96
	jr	z,.ramok

.ramng:
	ld	a,$0e
	out	($6f),a		; 0xE000`0xFFFFRAM߂
	ld	de,RAMNG_MSG
	ld	hl,$f000
	call	PNT_MSG
	jr	$

.diskng:
	ld	de,DISKNG_MSG
	ld	hl,$f000
	call	PNT_MSG
	jr	$

.ramok:

;
; fBXN[`OtRAMɓ]
;
	ld	a,$0a		; 0xa000-0xbfff̓ǂݏoRAM
	out	($65),a

	ld	hl,$ac00
	ld	de,$ac00
	ld	bc,$0300
	ldir

	ld	a,$2a		; 0xa000-0xbfff̓ǂݏoORAM
	out	($65),a

;
; BIOS[h
;
.retry1:
	ld	de,$000d	; Dreg=JngbNԍAEreg=JnZN^ԍ
	ld	bc,$0c00	; Breg=ZN^ACreg=hCuԍ
	ld	hl,$a000	; HL=i[AhX
	call	Disk_Load
	jr	c,.retry1

;
; 荞݃[`[h
;
.retry2:
	ld	de,$0109	; Dreg=JngbNԍAEreg=JnZN^ԍ
	ld	bc,$0100	; Breg=ZN^ACreg=hCuԍ
	ld	hl,$0000	; HL=i[AhX
	call	Disk_Load
	jr	c,.retry2

	ld	sp,$6000

	im	2
	ld	a,$00
	ld	i,a		; 荞݃e[u0x0000`ɐݒ

	ld	a,$fa		; 荞݂^C}ASUB-CPÛ݂ɂ
	out	($fa),a

	ld	a,$02
	out	($93),a		; ʂ

	ld	a,$fb		; CSS3-1=011
	out	($c0),a

	ld	a,$fb		; 320x200 OtBbN
	out	($c1),a

	ld	a,$e2		; rbg}bv[hɐݒ^y[WO\
	out	($c8),a

	ld	bc,$07c9
	xor	a
.outlp2:
	out	(c),a
				; 0xC9:VRAM}bv̐ݒ
				; 0xCA:XN[XW̐ݒ
				; 0xCB:XN[XW̐ݒ
				; 0xCC:XN[YW̐ݒ
				; 0xCD:XN[YW̐ݒ
				; 0xCE:YWiʁj̐ݒ
				; 0xCF:YWiʁj̐ݒ
	inc	c
	djnz	.outlp2

	ld	bc,$0440
	xor	a
.outlp3:
	out	(c),a		; pbg̏
	inc	a
	inc	c
	djnz	.outlp3

	ld	a,$ea		; ڃANZX[hɐݒ^y[WO\
	out	($c8),a

	ld	a,$03
	out	($93),a		; ʂ\

	ld	a,$07
	out	($a0),a		; ~LT[
	ld	a,$bf
	out	($a1),a		; S`lOFF

	ei

	xor	a
	ld	($a99a),a	; Ƃ肠hCuPg
	ld	($a99b),a	; Ƃ肠PhCuݒ

	ld	a,$00
	ld	hl,OPENFILE
	call	$a000

OPENFILE:
	db	"OPNING",$ff


;
; ʃNAiLN^j
;
CURCLS:
	ld	hl,$f000
	ld	(hl),$20
	inc	hl
	ld	(hl),$0f
	inc	hl
	ld	de,$f000
	ex	de,hl
	ld	bc,40*25*2-1
	ldir
	ret

;
; \
;
PNT_MSG:
.msglp:
	ld	a,(de)
	inc	de
	or	a
	ret	z
	ld	(hl),a
	inc	hl
	inc	hl
	jr	.msglp


DISKNG_MSG:
	db	"Disk error",$00

RAMNG_MSG:
	db	"64K",$e9,$20				; USj
	db	"RAM",$96,$de,$20			; q`lJ
	db	$eb,$e2,$f6,$93,$e3,$de,$9d,$a1,$00	; Ђ悤āJB




	org	$c200
;
; Track#0 Sector#3-5
;

	phase	Disk_Routine

	include	"disk66.z80"	; hCupǂݏo[`

	dephase


	org	$c500
;
; Track#0 Sector#6-8
;

	phase	Disk_Routine

	include	"disk.z80"	; OthCupǂݏo[`

	dephase


	org	$c7ff
	db	$ff


end

